package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.DealerSettingService;
import com.gxwebsoft.shop.entity.DealerSetting;
import com.gxwebsoft.shop.param.DealerSettingParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 分销商设置表控制器
 *
 * @author 科技小王子
 * @since 2024-07-28 11:57:41
 */
@Api(tags = "分销商设置表管理")
@RestController
@RequestMapping("/api/shop/dealer-setting")
public class DealerSettingController extends BaseController {
    @Resource
    private DealerSettingService dealerSettingService;

    @ApiOperation("分页查询分销商设置表")
    @GetMapping("/page")
    public ApiResult<PageResult<DealerSetting>> page(DealerSettingParam param) {
        // 使用关联查询
        return success(dealerSettingService.pageRel(param));
    }

    @ApiOperation("查询全部分销商设置表")
    @GetMapping()
    public ApiResult<List<DealerSetting>> list(DealerSettingParam param) {
        // 使用关联查询
        return success(dealerSettingService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:dealerSetting:list')")
    @ApiOperation("根据id查询分销商设置表")
    @GetMapping("/{id}")
    public ApiResult<DealerSetting> get(@PathVariable("id") String id) {
        // 使用关联查询
        return success(dealerSettingService.getByIdRel(id));
    }

    @ApiOperation("添加分销商设置表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody DealerSetting dealerSetting) {
        if (dealerSettingService.save(dealerSetting)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改分销商设置表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody DealerSetting dealerSetting) {
        if (dealerSettingService.updateById(dealerSetting)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除分销商设置表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (dealerSettingService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加分销商设置表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<DealerSetting> list) {
        if (dealerSettingService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改分销商设置表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<DealerSetting> batchParam) {
        if (batchParam.update(dealerSettingService, "key")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除分销商设置表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (dealerSettingService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
